=== debian/changelog ===
micropython (1.19.1+ds-1) unstable; urgency=medium

  * New upstream release
    * Fix test fails with Python 3.10 (Closes: #1007090)
  * Bump Standards-Version to 4.6.1

 -- Yangfl <mmyangfl@gmail.com>  Sat, 23 Jul 2022 12:35:20 +0800
